//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Client.AnyTypeTest.AnyTypeTest
{
    
    
    /// <summary>
    /// Class that implements the IAnyTypeTest interface through SiLA2
    /// </summary>
    public partial class AnyTypeTestClient : IAnyTypeTest
    {
        
        private System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty> _anyTypeStringValue;
        
        private System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty> _anyTypeIntegerValue;
        
        private System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty> _anyTypeRealValue;
        
        private System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty> _anyTypeBooleanValue;
        
        private System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty> _anyTypeBinaryValue;
        
        private System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty> _anyTypeDateValue;
        
        private System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty> _anyTypeTimeValue;
        
        private System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty> _anyTypeTimestampValue;
        
        private System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty> _anyTypeListValue;
        
        private System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty> _anyTypeStructureValue;
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.test.anytypetest.v1.AnyTypeTest";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public AnyTypeTestClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
            InitLazyRequests();
        }
        
        /// <summary>
        /// Returns the Any type String value 'SiLA_Any_type_of_String_type'.
        /// </summary>
        public virtual Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeStringValue
        {
            get
            {
                return _anyTypeStringValue.Value;
            }
        }
        
        /// <summary>
        /// Returns the Any type Integer value 5124.
        /// </summary>
        public virtual Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeIntegerValue
        {
            get
            {
                return _anyTypeIntegerValue.Value;
            }
        }
        
        /// <summary>
        /// Returns an Any type Real value 3.1415926.
        /// </summary>
        public virtual Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeRealValue
        {
            get
            {
                return _anyTypeRealValue.Value;
            }
        }
        
        /// <summary>
        /// Returns the Any type Boolean value true.
        /// </summary>
        public virtual Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeBooleanValue
        {
            get
            {
                return _anyTypeBooleanValue.Value;
            }
        }
        
        /// <summary>
        /// Returns the Any type ASCII-encoded string value 'SiLA_Any_type_of_Binary_type' as Binary.
        /// </summary>
        public virtual Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeBinaryValue
        {
            get
            {
                return _anyTypeBinaryValue.Value;
            }
        }
        
        /// <summary>
        /// Returns the Any type Date value 05.08.2022 respective 08/05/2022, timezone +2.
        /// </summary>
        public virtual Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeDateValue
        {
            get
            {
                return _anyTypeDateValue.Value;
            }
        }
        
        /// <summary>
        /// Returns the Any type Time value 12:34:56, timezone +2.
        /// </summary>
        public virtual Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeTimeValue
        {
            get
            {
                return _anyTypeTimeValue.Value;
            }
        }
        
        /// <summary>
        /// Returns the Any type Timestamp value 2022-08-05 12:34:56, timezone +2.
        /// </summary>
        public virtual Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeTimestampValue
        {
            get
            {
                return _anyTypeTimestampValue.Value;
            }
        }
        
        /// <summary>
        /// Returns the Any type String List value ('SiLA 2', 'Any', 'Type', 'String', 'List')
        /// </summary>
        public virtual Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeListValue
        {
            get
            {
                return _anyTypeListValue.Value;
            }
        }
        
        /// <summary>
        /// Returns the following Any type Structure value:
        /// - String 'StringTypeValue' = 'A String value',
        /// - Integer 'IntegerTypeValue' = 83737665,
        /// - Date 'DateTypeValue' = 05.08.2022 respective 08/05/2022 timezone +2 )
        /// </summary>
        public virtual Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeStructureValue
        {
            get
            {
                return _anyTypeStructureValue.Value;
            }
        }
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty RequestAnyTypeStringValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeStringValue");
            try
            {
                Tecan.Sila2.DynamicClient.DynamicObjectProperty response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>>(_serviceName, "AnyTypeStringValue", "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeStringValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty RequestAnyTypeIntegerValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeIntegerValue");
            try
            {
                Tecan.Sila2.DynamicClient.DynamicObjectProperty response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>>(_serviceName, "AnyTypeIntegerValue", "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeIntegerValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty RequestAnyTypeRealValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeRealValue");
            try
            {
                Tecan.Sila2.DynamicClient.DynamicObjectProperty response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>>(_serviceName, "AnyTypeRealValue", "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeRealValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty RequestAnyTypeBooleanValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeBooleanValue");
            try
            {
                Tecan.Sila2.DynamicClient.DynamicObjectProperty response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>>(_serviceName, "AnyTypeBooleanValue", "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeBooleanValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty RequestAnyTypeBinaryValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeBinaryValue");
            try
            {
                Tecan.Sila2.DynamicClient.DynamicObjectProperty response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>>(_serviceName, "AnyTypeBinaryValue", "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeBinaryValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty RequestAnyTypeDateValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeDateValue");
            try
            {
                Tecan.Sila2.DynamicClient.DynamicObjectProperty response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>>(_serviceName, "AnyTypeDateValue", "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeDateValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty RequestAnyTypeTimeValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeTimeValue");
            try
            {
                Tecan.Sila2.DynamicClient.DynamicObjectProperty response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>>(_serviceName, "AnyTypeTimeValue", "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeTimeValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty RequestAnyTypeTimestampValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeTimestampValue");
            try
            {
                Tecan.Sila2.DynamicClient.DynamicObjectProperty response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>>(_serviceName, "AnyTypeTimestampValue", "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeTimestampValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty RequestAnyTypeListValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeListValue");
            try
            {
                Tecan.Sila2.DynamicClient.DynamicObjectProperty response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>>(_serviceName, "AnyTypeListValue", "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeListValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty RequestAnyTypeStructureValue()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeStructureValue");
            try
            {
                Tecan.Sila2.DynamicClient.DynamicObjectProperty response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.DynamicClient.AnyTypeDto>>(_serviceName, "AnyTypeStructureValue", "org.silastandard/test/AnyTypeTest/v1/Property/AnyTypeStructureValue", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Initializes lazies for non-observable properties.
        /// </summary>
        private void InitLazyRequests()
        {
            _anyTypeStringValue = new System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty>(RequestAnyTypeStringValue);
            _anyTypeIntegerValue = new System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty>(RequestAnyTypeIntegerValue);
            _anyTypeRealValue = new System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty>(RequestAnyTypeRealValue);
            _anyTypeBooleanValue = new System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty>(RequestAnyTypeBooleanValue);
            _anyTypeBinaryValue = new System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty>(RequestAnyTypeBinaryValue);
            _anyTypeDateValue = new System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty>(RequestAnyTypeDateValue);
            _anyTypeTimeValue = new System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty>(RequestAnyTypeTimeValue);
            _anyTypeTimestampValue = new System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty>(RequestAnyTypeTimestampValue);
            _anyTypeListValue = new System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty>(RequestAnyTypeListValue);
            _anyTypeStructureValue = new System.Lazy<Tecan.Sila2.DynamicClient.DynamicObjectProperty>(RequestAnyTypeStructureValue);
        }
        
        /// <summary>
        /// Receives an Any type value and returns the type and the value that has been received.
        /// </summary>
        /// <param name="anyTypeValue">The Any type value to be set.</param>
        public virtual SetAnyTypeValueResponse SetAnyTypeValue(Tecan.Sila2.DynamicClient.DynamicObjectProperty anyTypeValue)
        {
            SetAnyTypeValueRequestDto request = new SetAnyTypeValueRequestDto(anyTypeValue, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/AnyTypeTest/v1/Command/SetAnyTypeValue");
            try
            {
                SetAnyTypeValueResponse response = _channel.ExecuteUnobservableCommand<SetAnyTypeValueRequestDto, SetAnyTypeValueResponseDto>(_serviceName, "SetAnyTypeValue", request, callInfo).Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Any Type Test.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class AnyTypeTestClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/test/AnyTypeTest/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IAnyTypeTest);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new AnyTypeTestClient(channel, executionManager);
        }
    }
}

